/* 5. Scrivere un programma per la gestione di matrici di double, che contenga i seguenti metodi:

Una funzione CREATE, che riceve due interi (dimensione di righe e colonne), crea una matrice delle dimensioni indicate, e restituisce il suo puntatore.
Un metodo ERASE, che azzera tutti gli elementi della matrice.
Un metodo READ per la lettura di una matrice da tastiera.
Un metodo PRINT per la stampa della matrice su output.
Un metodo MULT che effettui il prodotto di due matrici, restituendo il puntatore alla matrice risultante. 
*/

#include <stdio.h>
#include <stdlib.h>

double** create(int,int);
void erase(double**, int, int);
void read(double**, int, int);
void print(double**,int,int);
double** mult(double**,double**, int,int,int);

int main(){
    int r1,c1,r2,c2;
    
    printf ("Matrice 1 numero di righe > ");
    scanf ("%d",&r1);
    printf ("Matrice 1 numero di colonne > ");
    scanf ("%d",&c1);
    
    printf ("Matrice 2 numero di righe > ");
    scanf ("%d",&r2);
    printf ("Matrice 2 numero di colonne > ");
    scanf ("%d",&c2);
    
    double** mat1=create(r1,c1);
    double** mat2=create(r2,c2);
    
    printf("inserisci matrice 1 %dx%d\n", r1,c1);
    read(mat1, r1, c1);
    print(mat1,r1, c1);
    printf("inserisci matrice 2 %dx%d\n", r2,c2);
    read(mat2, r2, c2);
    print(mat2,r2, c2);
    
    double** mat3=mult(mat1, mat2, r1, c1, c2);
    printf("matrice m3:\n");
    print(mat3, r1, c2);
    
    printf("cancello m1:\n");
    erase(mat1,r1,c1);
    print(mat1,r1, c1);
    
}

double** create(int r,int c){
    double** mat=(double**) malloc(r*sizeof(double*));
    if (mat==NULL)
    {
        printf ("MEMORIA NON DISPONIBILE! \n");
        exit(-1);
    }
    int i;    
    for (i=0;i<r;i++){
        mat[i]=(double*) malloc (c*sizeof(double));
        if (mat[i]==NULL)
        {
            printf ("MEMORIA NON DISPONIBILE! \n");
            free(mat);
            exit(-1);
        }
    }//for malloc
    
    return mat;
}

void erase(double** mat, int r, int c){
    int i,j;
    for(i=0; i<r;i++)
        for (j=0;j<c;j++)
            mat[i][j]=0;
}

void read(double** mat, int r, int c){
    int i,j;
    for (i=0;i<r;i++)
    {
        for (j=0;j<c;j++)
        {
            printf ("Inserisci elemento [%d,%d] > ",i,j);
            scanf ("%lf", &mat[i][j]);
        }
    }//for i
}

void print(double** mat,int r,int c){
    int i,j;
    for (i=0;i<r;i++)
    {
        for (j=0;j<c;j++)
        {
            printf ("%lf ",mat[i][j]);
        }
        printf("\n");
    }//for i
}

double** mult(double** m1,double** m2, int r1,int c1,int c2){
    //m1= r1xc1
    //m2= r2xc2 = c1xc2
    //m3= r1xc2
    double** m3= create(r1,c2);
    int i,j,k;
    
    for (i=0; i<r1; i++)
        for (j=0; j<c2; j++) {
            m3[i][j]=0;
            for (k=0; k<c1; k++)             
                m3[i][j] += m1[i][k] * m2[k][j];
        }
    
    return m3;
}
